import type { Path } from '../jsutils/Path.js';
import type { DeferUsage } from './collectFields.js';
import type {
  PendingExecutionGroup,
  StreamRecord,
  SuccessfulExecutionGroup,
} from './types.js';
export type DeliveryGroup = DeferredFragmentRecord | StreamRecord;
/** @internal */
export declare class DeferredFragmentRecord {
  path: Path | undefined;
  label: string | undefined;
  parentDeferUsage: DeferUsage | undefined;
  id?: string | undefined;
  pendingExecutionGroups: Set<PendingExecutionGroup>;
  successfulExecutionGroups: Set<SuccessfulExecutionGroup>;
  children: Set<DeliveryGroup>;
  constructor(
    path: Path | undefined,
    label: string | undefined,
    parentDeferUsage: DeferUsage | undefined,
  );
}
export declare function isDeferredFragmentRecord(
  deliveryGroup: DeliveryGroup,
): deliveryGroup is DeferredFragmentRecord;
/**
 * @internal
 */
export declare class DeferredFragmentFactory {
  private _rootDeferredFragments;
  get(deferUsage: DeferUsage, path: Path | undefined): DeferredFragmentRecord;
  private _pathAtDepth;
}
